
import java.util.ArrayList;
import java.util.Iterator;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author Ucebna
 */
public class Path {

    MainForm mf;
    int[][] map = new int[20][20];
    String path;
    ArrayList<String> commands;

    public Path(MainForm mf) {
        this.mf = mf;
    }

    void find() {
        map = new int[20][20];
        step(1, mf.poklad.x, mf.poklad.y);
        for (int i = 0; i < map.length; i++) {
            int[] radek = map[i];
            for (int j = 0; j < radek.length; j++) {
                int k = radek[j];
                System.out.format("%4d", k);
            }
            System.out.println("");
        }
    }

    void step(int i, int x, int y) {
        boolean next = false;
        try {
            if (mf.map[y - 1][x - 1] == '.' | mf.map[y - 1][x - 1] == '$') {
                if (map[y - 1][x - 1] == 0 | map[y - 1][x - 1] > i) {
                    map[y - 1][x - 1] = i;
                    next = true;
                }
            }
        } catch (StringIndexOutOfBoundsException ex) {
            return;
        } catch (ArrayIndexOutOfBoundsException ex) {
            return;
        }
        if (next) {
            step(i + 1, x + 1, y);
            step(i + 1, x - 1, y);
            step(i + 1, x, y + 1);
            step(i + 1, x, y - 1);
        }
    }

    String getCommand(String available) {
        System.out.println("GETCOMMAND");
        commands = new ArrayList<String>();
        addSingleCommand("", available);
        int best = 10000;
        int now;
        Position p;
        String out = "";
        for (Iterator<String> it = commands.iterator(); it.hasNext();) {
            String command = it.next();
            if (command.startsWith("R3"))System.out.println("             "+command);
            p = mf.robotEnds(command.toCharArray());
            if (p != null) {
                System.out.print(" " + command);
                now = map[p.y - 1][p.x - 1];
                System.out.print(" " + now);
                if (now < best) {
                    best = now;
                    System.out.print(" BEST");
                    out = command;
                }
                System.out.println("");
            }
        }
        return out;
    }

    void addSingleCommand(String command, String available) {
        if (command.length() == 5) {
            commands.add(command);
        } else {
            if (available.contains("1")) {
                addSingleCommand(command + "1", available.replaceFirst("1", " "));
            }
            if (available.contains("2")) {
                addSingleCommand(command + "2", available.replaceFirst("2", " "));
            }
            if (available.contains("3")) {
                addSingleCommand(command + "3", available.replaceFirst("3", " "));
            }
            if (available.contains("Z")) {
                addSingleCommand(command + "Z", available.replaceFirst("Z", " "));
            }
            if (available.contains("R")) {
                addSingleCommand(command + "R", available.replaceFirst("R", " "));
            }
            if (available.contains("L")) {
                addSingleCommand(command + "L", available.replaceFirst("L", " "));
            }
        }
    }
}
