/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author Ucebna
 */
class Position {

    int x;
    int y;
    int heading;

    public Position(Position p) {
        x = p.x;
        y = p.y;
        heading = p.heading;
    }

    public Position(int x, int y, String heading) {
        this.x = x;
        this.y = y;
        char c = heading.charAt(0);
        switch (c) {
            case 'N':
                this.heading = 0;
                break;

            case 'R':
                this.heading = 1;
                break;
            case 'D':
                this.heading = 2;
                break;
            case 'L':
                this.heading = 3;
        }
    }

    public Position(int x, int y) {
        this.x = x;
        this.y = y;
        heading = 0;
    }
    public Position(int x, int y, int heading) {
        this.x = x;
        this.y = y;
        this.heading = heading;
    }

    @Override
    public String toString() {
        return String.format("Position X: %d Y: %d Otoceni: %d", x, y, heading);
    }

    Position getPositionOnStep(int steps){
        switch(heading){
            case 0:return new Position(x, y-steps, 0);
            case 1:return new Position(x+steps, y, 1);
            case 2:return new Position(x, y+steps, 2);
            case 3:return new Position(x-steps, y, 3);
        }
        return null;
    }

    void turn(char c){
        if (c=='R'){
            heading++;
            if (heading>=4)heading-=4;
        }
        if (c=='L'){
            heading--;
            if (heading<0)heading+=4;
        }
    }
}
